#!/usr/bin/perl

#use strict;
#no strict 'subs';
use Data::Dumper;
use Tie::ShareLite qw( :lock );
my %licstatus;
  $ipc = tie %licstatus, 'Tie::ShareLite', -key     => 2030405,
					-mode    => 0666,
                                        -create  => 'yes',
                                        -destroy => 'no'
    or die("Could not tie to shared memory: $!");

my $lmutil = '/usr/local/sbin/lmutil';

# "Common name" translation hash.
my %tr = (
        'alterad' => 'Altera',
        'cdslmd' => 'Cadence',
        'MLM' => 'MATLAB',
        'merant' => 'Merant',
        'telelogic' => 'Telelogic',
        'synplctyd' => 'Synplicity',
        'snpslmd' => 'Synopsys',
        'mgcld' => 'ModelTech',
        'armlmd' => 'ARM',
);

# Servers to poll, daemon name, and TCP port
my %licservers = (
        'lic1.example.com'    => { 
                'MLM'   	=> '20007',
                'cdslmd'        => '5230',
                'mgcld'         => '1719',
                'armlmd'        => '8422',
                'snpslmd'       => '2005',
        },
        'lic2.example.com'    => {
                'MLM'           => '27005',
                'synplctyd'     => '1710',
                'cdslmd'        => '5580' 
        },
        'lic3.example.com'        =>  { 
                'merant'        => '27004', 
                'cdslmd'        => '5201',
                'telelogic'     => '1933',
                'alterad'       => '1715'
        }, 
);



sub do_poll() {
$0 = "lmgrd-poller.pl: Polling...";
my $server;
$ipc->lock( LOCK_SH );
foreach my $lserver ( keys %licservers ) {
	foreach my $app ( keys %{$licservers{$lserver}} ) {
		my $server = "$licservers{$lserver}{$app}\@$lserver";
		open(LICENSES, "$lmutil lmstat -c $server -a|") or die("Couldn't run $lmutil.");

		foreach my $line (<LICENSES>) {
	 		if ($line =~ /^Users\sof\s(.+):\s+\(Total\sof\s(\d+)\s\w+\sissued;\s+Total\sof\s(\d+)\s\w+\sin\suse\)/) {

				# Well, this is stupid.
				my %tmpstat = %licstatus;
				$tmpstat{$lserver}{$1}{total} = $2;
				$tmpstat{$lserver}{$1}{package} = $tr{$app};
				$tmpstat{$lserver}{$1}{inuse} = $3;
				$tmpstat{$lserver}{$1}{port} = $licservers{$lserver}{$app};
				%licstatus = %tmpstat;
#				print Dumper %licstatus;
	 		}
		}
		close(LICENSES);
	}
}
$ipc->unlock();
}
sub daemonize {
   # open STDOUT, ">>$log" or die "Can't write to $log: $!";
    defined(my $pid = fork)   or die "Can't fork: $!";
    exit if $pid;
    setsid                    or die "Can't start a new session: $!";
    umask 0;
}

&daemonize;

while (true) {
	&do_poll();
	$0 = "lmgrd-poller.pl: Sleeping...";
	sleep 240;
}

#print Dumper %licstatus;
